# sh3_disass.py version 003
# -*- coding: iso-8859-15 -*-
__version__ = "20110122" 

import getopt
import os
import sys
import string
import struct
import binascii


uregs = {    # user registers
"R0" : 0xffffffff,
"R1" : 0xffffffff,
"R2" : 0xffffffff,
"R3" : 0xffffffff,
"R4" : 0xffffffff,
"R5" : 0xffffffff,
"R6" : 0xffffffff,
"R7" : 0xffffffff,
"R8" : 0xffffffff,
"R9" : 0xffffffff,
"R10" : 0xffffffff,
"R11" : 0xffffffff,
"R12" : 0xffffffff,
"R13" : 0xffffffff,
"R14" : 0xffffffff,
"R15" : 0xffffffff,
"SR" : 0xffffffff,
"SSR" : 0xffffffff,
"GBR" : 0xffffffff,
"VBR" : 0xffffffff,
"MACH" : 0xffffffff,
"MACL" : 0xffffffff,
"PR" : 0xffffffff,
"PC" : 0xffffffff,
"SPC" : 0xffffffff
        }

def disassemble(hinstr):
   global uregs
   global dataref
   global coderef
   global pc
   global pi
   global pcstart
   global start
   global sh3asm
   nib1 = hinstr[0:1]
   nib2 = hinstr[1:2]
   nib3 = hinstr[2:3]
   nib4 = hinstr[3:4]
# ----- on data ? -----
   if dataref.has_key("%X" % (pi)) :
    print ".data %s" % ( dataref["%X" % (pi)] )
    if dataref["%X" % (pi)].find("dword") > -1: 
     pc+=2
     pi+=2
    return
# ----- on code reference ? -----
   if coderef.has_key("%X" % (pi)):
    print "               ;code ref:%s" % ( coderef["%X" % (pi)] )
    print "%08X:" % (pc),
# ---- 	Data Transfer instructions:
   if nib1 == 'E':
    if int(nib3+nib4,16) >= 0x80:
     print "MOV $-%X, R%d" % (0x100-int(nib3+nib4,16), int(nib2,16))  
     uregs["R%d" % int(nib2,16)] = int(nib3+nib4,16)-0x100
    else:
     print "MOV $%s, R%d" % (nib3+nib4, int(nib2,16))                                 #Enii
     uregs["R%d" % int(nib2,16)] = int(nib3+nib4,16)
    return
   if nib1 == '9':
    dataoffset =  "%X" % (pi & 0xFFFFFFFF + 4 + 2*int(nib3 + nib4,16))
    word = binascii.hexlify(sh3asm[pi + 4 + 2*int(nib3 + nib4,16):pi + 2*int(nib3 + nib4,16) + 6])
#    print "MOV.W @($%s*2+PC),R%d = #Rn & 0x8000 ? %s|$FFFF0000 : %s" % (nib3 + nib4,int(nib2,16),word,word)    #9ndd
    print "MOV.W @($%s*2+PC),R%d = #%X" % (nib3 + nib4,int(nib2,16),(int(word,16),int(word,16) | 0xFFFF0000)[uregs["R%d" % int(nib2,16)] & 0x8000 == 0x8000])   #9ndd	
    dataref[dataoffset] = word + " word ref:" + "%X" % (pc)
    uregs["R%d" % int(nib2,16)] =  (int(word,16),int(word,16) | 0xFFFF0000)[uregs["R%d" % int(nib2,16)] & 0x8000 == 0x8000] 
    return
   if nib1 == 'D':
    PI = pi & 0xFFFFFFFC
    dataoffset =  "%X" % (PI + 4 + 4*int(nib3 + nib4,16))
    dword = binascii.hexlify(sh3asm[PI + 4 + 4*int(nib3 + nib4,16):PI + 4 + 4*int(nib3 + nib4,16) + 4])
    print "MOV.L @($%s*4+PC),R%d = #%s"  % (nib3 + nib4,int(nib2,16), dword.upper()) #Dndd
    dataref[dataoffset] = dword + " dword ref:" + "%X" % (pc)
    uregs["R%d" % int(nib2,16)] = int(dword,16)
    return	   							
   if nib1 == '6' and nib4 == '3':
    print "MOV R%d, R%d" % (int(nib3,16),int(nib2,16))   #	6nm3
    uregs["R%d" % int(nib2,16)] = uregs["R%d" % int(nib3,16)]
    return	   							
   if nib1 == '2' and nib4 == '0':
    print "MOV.B R%d,@R%d => %X = [%X]" % (int(nib3,16),int(nib2,16),uregs["R%d" % int(nib3,16)]&0xff,uregs["R%d" % int(nib2,16)])  #	2nm0   byte
#    sh3asm[uregs["R%d" % int(nib2,16)]:uregs["R%d" % int(nib2,16)]+4] = uregs["R%d" % int(nib3,16)] & 0xff
    dataoffset =  "%X" % (pi + 4 + 4*int(nib3 + nib4,16))
    return	   							
   if nib1 == '2' and nib4 == '1':
    print "MOV.W R%d,@R%d => %X = [%X]" % (int(nib3,16),int(nib2,16),uregs["R%d" % int(nib3,16)]&0xffff,uregs["R%d" % int(nib2,16)]) # 2nm1   word	
#    sh3asm[uregs[R+nib2]:uregs[R+nib2]+4] = uregs["R%d" % int(nib3,16)] & 0xffff  					
    return
   if nib1 == '2' and nib4 == '2':
    print "MOV.L R%d,@R%d => %X = [%X]" % (int(nib3,16),int(nib2,16),uregs["R%d" % int(nib3,16)],uregs["R%d" % int(nib2,16)])         # 2nm2   dword
#?    sh3asm[uregs[R+nib2]:uregs[R+nib2]+4] = uregs["R%d" % int(nib3,16)]	  					
    return
   if nib1 == '6' and nib4 == '0':
    print "MOV.B @R%d,R%d" % (int(nib3,16),int(nib2,16)) #	6nm0	
#    uregs["R%d" % int(nib2,16)] = sh3asm[uregs["R%d" % int(nib3,16)]:] & 0xff  					
    return
   if  nib1 == '6' and nib4 == '1':
    print "MOV.W @R%d,R%d" % (int(nib3,16),int(nib2,16)) #	6nm1	
    #uregs["R%d" % int(nib2,16)] = struct.unpack(">H",sh3asm[uregs["R%d" % int(nib3,16)]:uregs["R%d" % int(nib3,16)]+2])  					
    return
   if  nib1 == '6' and nib4 == '2':
    print "MOV.L @R%d,R%d" % (int(nib3,16),int(nib2,16)) #	6nm2
    #uregs["R%d" % int(nib2,16)] = int(binascii.hexlify(sh3asm[uregs["R%d" % int(nib3,16)]:uregs["R%d" % int(nib3,16)]+4] ),16)	 
    return
   if  nib1 == '2' and nib4 == '4':
    print"MOV.B R%d,@R%d" % (int(nib3,16),int(nib2,16)) #	2nm4
    return
   if  nib1 == '2' and nib4 == '5':
    print "MOV.W R%d,@-R%d" % (int(nib3,16),int(nib2,16)) #	2nm5			
    return
   if  nib1 == '2' and nib4 == '6':
    print "MOV.L R%d,@-R%d" % (int(nib3,16),int(nib2,16)) #	2nm6	  		
    return
   if  nib1 == '6' and nib4 == '4':
    print "MOV.B @R%d+,R%d" % (int(nib3,16),int(nib2,16)) #	6nm4	  		
    return
   if  nib1 == '6' and nib4 == '5':
    print "MOV.W @R%d+,R%d" % (int(nib3,16),int(nib2,16)) #	6nm5	  		
    return
   if  nib1 == '6' and nib4 == '6':
    print "MOV.L @R%d+,R%d" % (int(nib3,16),int(nib2,16)) #	6nm6	  		
    return
   if  nib1 == '8' and nib2 == '0':
    print "MOV.B R0,@($%s+R%d)" % (nib4,int(nib3,16))     #	80nd	 		
    return
   if nib1 == '8' and nib2 == '1':
    print "MOV.W R0,@($%s*2+R%d)" % (nib4,int(nib3,16))   #	81nd	   		
    return
   if nib1 == '1':
    print "MOV.L R%d,@($%s*4+R%d)" % (int(nib3,16), nib4, int(nib2,16))  #    	1nmd			
    return
   if nib1 == '8' and nib2 == '4':
    print "MOV.B @($%s+R%d),R0" % (nib4,int(nib3,16))     #	84md	   		
    return
   if nib1 == '8' and nib2 == '4':
    print "MOV.W @($%s*2+R%d),R0" % (nib4,int(nib3,16))   #	85md	   		
    return
   if nib1 == '5':
    print "MOV.L @($%s*4+R%d),R%d" % (nib4,int(nib3,16), int(nib2,16))   #	5nmd				
    return
   if nib1 == '0' and nib4 == '4':
    print "MOV.B R%d,@(R0+R%d)" % (int(nib3,16),int(nib2,16)) #		0nm4	  	
    return
   if nib1 == '0' and nib4 == '5':
    print "MOV.W R%d,@(R0+R%d)" % (int(nib3,16),int(nib2,16)) #		0nm5	   	
    return
   if nib1 == '0' and nib4 == '6':
    print "MOV.L R%d,@(R0+R%d)" % (int(nib3,16),int(nib2,16)) #		0nm6	   	
    return
   if nib1 == '0' and nib4 == 'C':
    print "MOV.B @(R0+R%d),R%d" % (int(nib3,16),int(nib2,16)) #		0nmC 			
    return
   if nib1 == '0' and nib4 == 'D':
    print "MOV.W @(R0+R%d),R%d" % (int(nib3,16),int(nib2,16)) #		0nmD			
    return
   if nib1 == '0' and nib4 == 'E':
    print "MOV.L @(R0+R%d),R%d" % (int(nib3,16),int(nib2,16)) #		0nmE	  	
    return
   if nib1 == 'C' and nib2 == 'O':
    print "MOV.B R0,@($%s+GBR)" % (nib3 + nib4)               #		C0dd	  	
    return
   if nib1 == 'C' and nib2 == '1':
    print "MOV.W R0,@($%s*2+GBR)" % (nib3 + nib4)             #	        C1dd	  	
    return
   if nib1 == 'C' and nib2 == '2':
    print "MOV.L R0,@($%s*4+GBR)" % (nib3 + nib4)             #	        C2dd	  	
    return
   if nib1 == 'C' and nib2 == '4':
    print "MOV.B @($%s+GBR),R0" % (nib3 + nib4)               #		C4dd	  	
    return
   if nib1 == 'C' and nib2 == '5':
    print "MOV.W @($%s*2+GBR),R0" % (nib3 + nib4)             #  	C5dd	   	
    return
   if nib1 == 'C' and nib2 == '6':
    print "MOV.W @($%s*4+GBR),R0" % (nib3 + nib4)             #	        C6dd	   	
    return
   if nib1 == 'C' and nib2 == '7':
    PC = 4 + pc & 0xFFFFFFFC
    print "MOVA @($%s*4+PC),R0 = #%X" % (nib3 + nib4,PC + 4*int(nib3 + nib4,16))    #		C7dd	 						
    return
   if nib1 == '0' and nib3 == '2' and nib4 == '9' :
    print "MOVT R%d" % (int(nib2,16))   	              #		0n29	  
    return
   if nib1 == '0' and nib3 == '8' and nib4 == '3':
    print "PREF @R%d" % (int(nib2,16))                        #		0n83	  
    return
   if nib1 == '6' and nib4 == '8':
    print "SWAP.B R%d,R%d" % (int(nib3,16),int(nib2,16))      #		6nm8	  
    return
   if nib1 == '6' and nib4 == '9':
    print "SWAP.W R%d,R%d" % (int(nib3,16),int(nib2,16))      #		6nm9	  
    return
   if nib1 == '2' and nib4 == 'D':
    print "XTRCT R%d,R%d" % (int(nib3,16),int(nib2,16))       #		2nmD	  
    return
# ---- Arithmetic instructions:				
   if nib1 == '3' and nib4 == 'C':
    print "ADD R%d,R%d" % (int(nib3,16),int(nib2,16))         #		3nmC	 
    return
   if nib1 == '7':
    if int(nib3+nib4,16) >= 0x80:
     print "MOV $-%X, R%d" % (0x100-int(nib3+nib4,16), int(nib2,16))      
    else:
     print "ADD $%s,R%d" % (nib3+nib4,int(nib2,16))  	      #		7nii	  
    return
   if nib1 == '3' and nib4 == 'E':
    print "ADDC R%d,R%d" % (int(nib3,16),int(nib2,16))        #		3nmE	
    return
   if nib1 == '3' and nib4 == 'F':
    print "ADDV R%d,R%d" % (int(nib3,16),int(nib2,16))        #		3nmF	
    return
   if nib1 == '8' and nib2 == '8':
    print "CMP/EQ $%s,R0" % (nib3 + nib4) 		      #		88ii
    return
   if nib1 == '3' and nib4 == '0':
    print "CMP/EQ R%d,R%d" % (int(nib3,16),int(nib2,16))      #		3nm0
    return
   if nib1 == '3' and nib4 == '2':
    print "CMP/HS R%d,R%d" % (int(nib3,16),int(nib2,16))      #		3nm2
    return
   if nib1 == '3' and nib4 == '3':
    print "CMP/GE R%d,R%d" % (int(nib3,16),int(nib2,16))      #		3nm3	
    return
   if nib1 == '3' and nib4 == '6':
    print "CMP/HI R%d,R%d" % (int(nib3,16),int(nib2,16))      #		3nm6	
    return
   if nib1 == '3' and nib4 == '7':
    print "CMP/GT R%d,R%d" % (int(nib3,16),int(nib2,16))      #		3nm7
    return
   if nib1 == '4' and nib3 == '1' and nib4 == '1':
    print "CMP/PZ R%d" % (int(nib2,16)) 		      #		4n11	
    return
   if nib1 == '4' and nib3 == '1' and nib4 == '5':
    print "CMP/PL R%d" % (int(nib2,16)) 		      #		4n15	
    return
   if nib1 == '2' and nib4 == 'C':
    print "CMP/STR R%d,R%d" % (int(nib3,16),int(nib2,16))     #		2nmC
    return
   if nib1 == '3' and nib4 == '4':
    print "DIV1 R%d,R%d" % (int(nib3,16),int(nib2,16))        #		3nm4	
    return
   if nib1 == '2' and nib4 == '7':
    print "DIV0S R%d,R%d" % (int(nib3,16),int(nib2,16))       #		2nm7
    return
   if nib1 == '0' and nib2 == '0' and nib3 == '1' and nib4 == 'A':
    print "DIV0U" 					      #		001A	
    return
   if nib1 == '3' and nib4 == 'D':
    print "DMULS.L R%d,R%d" % (int(nib3,16),int(nib2,16))     #		3nmD
    return
   if nib1 == '3' and nib4 == '5':
    print "DMULU.L R%d,R%d" % (int(nib3,16),int(nib2,16))     #		3nm5	
    return
   if nib1 == '4' and nib3 == '1' and nib4 == '0':
    print "DT R%d" % (int(nib2,16)) 			      #		4n10	  
    return
   if nib1 == '6' and nib4 == 'E':
    print "EXTS.B R%d,R%d" % (int(nib3,16),int(nib2,16))      #		6nmE	  
    return
   if nib1 == '6' and nib4 == 'F':
    print "EXTS.W R%d,R%d" % (int(nib3,16),int(nib2,16))      #		6nmF	  
    return
   if nib1 == '6' and nib4 == 'C':
    print "EXTU.B R%d,R%d" % (int(nib3,16),int(nib2,16))      #		6nmC	  
    return
   if nib1 == '6' and nib4 == 'D':
    print "EXTU.W R%d,R%d" % (int(nib3,16),int(nib2,16))      #		6nmD	  
    return
   if nib1 == '0' and nib4 == 'F':
    print "MAC.L @R%d+,@R%d+" % (int(nib3,16),int(nib2,16))   #		0nmF	  
    return
   if nib1 == '4' and nib4 == 'F':
    print "MAC.W @R%d+,@R%d+" % (int(nib3,16),int(nib2,16))   #		4nmF	  
    return
   if nib1 == '0' and nib4 == '7':
    print "MUL.L R%d,R%d" % (int(nib3,16),int(nib2,16))       #		0nm7	  
    return
   if nib1 == '2' and nib4 == 'F':
    print "MULS.W R%d,R%d" % (int(nib3,16),int(nib2,16))      #		2nmF	  
    return
   if nib1 == '2' and nib4 == 'E':
    print "MULU.W R%d,R%d" % (int(nib3,16),int(nib2,16))      #		2nmE	  		
    return
   if nib1 == '6' and nib4 == 'B':
    print "NEG R%d,R%d" % (int(nib3,16),int(nib2,16))         #		6nmB	  
    return
   if nib1 == '6' and nib4 == 'A':
    print "NEGC R%d,R%d" % (int(nib3,16),int(nib2,16))        #		6nmA	 
    return
   if nib1 == '3' and nib4 == '8':
    print "SUB R%d,R%d" % (int(nib3,16),int(nib2,16))         #		3nm8	  
    return
   if nib1 == '3' and nib4 == 'A':
    print "SUBC R%d,R%d" % (int(nib3,16),int(nib2,16))        #		3nmA	  
    return
   if nib1 == '3' and nib4 == 'B':
    print "SUBV R%d,R%d" % (int(nib3,16),int(nib2,16))        #		3nmB	
    return
# ---- Logical operations:			
   if nib1 == '2' and nib4 == '9':
    print "AND R%d,R%d" % (int(nib3,16),int(nib2,16))         #		2nm9	  
    return
   if nib1 == 'C' and nib2 == '9':
    print "AND $%s,R0" % (nib3 + nib4)                        #		C9ii	  
    return
   if nib1 == 'C' and nib2 == 'D':
    print "AND.B $%s,@(R0+GBR)" % (nib3 + nib4)	              #		CDii	
    return
   if nib1 == '6' and nib4 == '7':
    print "NOT R%d,R%d" % (int(nib3,16),int(nib2,16))         #		6nm7	  
    return
   if nib1 == '2' and nib4 == 'B':
    print "OR R%d,R%d" % (int(nib3,16),int(nib2,16))          #		2nmB	  
    return
   if nib1 == 'C' and nib2 == 'B':
    print "OR $%s,R0" % (nib3 + nib4)                         #		CBii	  
    return
   if nib1 == 'C' and nib2 == 'F':
    print "OR.B $%s,@(R0+GBR)" % (nib3 + nib4) 		      #		CFii	 
    return
   if nib1 == '4' and nib3 == '1' and nib4 == '8':
    print "TAS.B @R%d" % (int(nib2,16)) 		      #		4nm8	 
    return
   if nib1 == '2' and nib4 == '8':
    print "TST R%d,R%d" % (int(nib3,16),int(nib2,16)) 	      #		2nm8	  
    return
   if nib1 == 'C' and nib2 == '8':
    print "TST $%s,R0" % (nib3 + nib4) 			      #		c8ii	
    return
   if nib1 == 'C' and nib2 == 'C':
    print "TST.B $%s,@(R0+GBR)" % (nib3 + nib4) 	      #		CCii	
    return
   if nib1 == '2' and nib4 == 'A':
    print "XOR R%d,R%d" % (int(nib3,16),int(nib2,16)) 	      #		2nmA	
    return
   if nib1 == 'C' and nib2 == 'A':
    print "XOR $%s,R0" % (nib3 + nib4) 			      #		CAii	
    return
   if nib1 == 'C' and nib2 == 'E':
    print "XOR.B $%s,@(R0+GBR)" % (nib3 + nib4) 	      #		CEii	 
    return
# ---- Shift instructions:				
   if nib1 == '4' and nib3 == '0' and nib4 == '4':
    print "ROTL R%d" % (int(nib2,16))  			      #		4n04	 
    return
   if nib1 == '4' and nib3 == '0' and nib4 == '5':
    print "ROTR R%d" % (int(nib2,16))  			      #		4n05	 
    return
   if nib1 == '4' and nib3 == '2' and nib4 == '4':
    print "ROTCL R%d" % (int(nib2,16))  		      #		4n24	 
    return
   if nib1 == '4' and nib3 == '2' and nib4 == '5':
    print "ROTCR R%d" % (int(nib2,16))  		      #		4n25	 
    return
   if nib1 == '4' and nib4 == 'C':
    print "SHAD R%d,R%d" % (int(nib3,16),int(nib2,16))        #		4nmC	  
    return
   if nib1 == '4' and nib3 == '2' and nib4 == '0':
    print "SHAL R%d" % (int(nib2,16))  			      #		4n20	  
    return
   if nib1 == '4' and nib3 == '2' and nib4 == '1':
    print "SHAR R%d" % (int(nib2,16))  			      #		4n21	  	
    return
   if nib1 == '4' and nib4 == 'D':
    print "SHLD R%d,R%d" % (int(nib3,16),int(nib2,16)) 	      #		4nmD		
    return
   if nib1 == '4' and nib3 == '0' and nib4 == '0':
    print "SHLL R%d" % (int(nib2,16))  			      #		4n00	 
    return
   if nib1 == '4' and nib3 == '0' and nib4 == '1':
    print "SHLR R%d" % (int(nib2,16))  			      #		4n01	 
    return
   if nib1 == '4' and nib3 == '0' and nib4 == '8':
    print "SHLL2 R%d" % (int(nib2,16))  		      #		4n08	  
    return
   if nib1 == '4' and nib3 == '0' and nib4 == '9':
    print "SHLR2 R%d" % (int(nib2,16)) 			      #		4n09	  
    return
   if nib1 == '4' and nib3 == '1' and nib4 == '8':
    print "SHLL8 R%d" % (int(nib2,16)) 			      #		4n18	  
    return
   if nib1 == '4' and nib3 == '1' and nib4 == '9':
    print "SHLR8 R%d" % (int(nib2,16)) 			      #		4n19	  
    return
   if nib1 == '4' and nib3 == '2' and nib4 == '8':
    print "SHLR8 R%d" % (int(nib2,16)) 			      #		4n28	  
    return
   if nib1 == '4' and nib3 == '2' and nib4 == '9':
    print "SHLR16 R%d" % (int(nib2,16)) 		      #		4n29	  
    return
# ---- Branch instructions:				
   if nib1 == '8' and nib2 == 'B':  
    if int(nib3 + nib4,16) >= 0x80:
     print "BF $%X" % (pc +4 + 2*(int(nib3 + nib4,16) -0x100))  #	8Bdd
     codeoffset = "%X" % (pi + 4 + 2*(int(nib3 + nib4,16) - 0x100))
     #coderef[codeoffset] = "%X" % (pc)	   					
    else:
     print "BF $%X" % (pc + 4 + 2*int(nib3 + nib4,16)) 
     codeoffset = "%X" % (pi + 4 + 2*int(nib3 + nib4,16))
     coderef[codeoffset] = "%X" % (pc)	
    return
   if nib1 == '8' and nib2 == 'F':
    if int(nib3 + nib4,16) >= 0x80:
     print "BF/S $%X" % (pc +4 + 2*(int(nib3 + nib4,16) -0x100))  #	8Fdd
     codeoffset = "%X" % (pi + 4 + 2*(int(nib3 + nib4,16) - 0x100))
     #coderef[codeoffset] = "%X" % (pc)	 	   				
    else:
     print "BF/S $%X" % (pc + 4 + 2*int(nib3 + nib4,16)) 
     codeoffset = "%X" % (pi + 4 + 2*int(nib3 + nib4,16))
     coderef[codeoffset] = "%X" % (pc) 	   					
    return
   if nib1 == '8' and nib2 == '9':
    if int(nib3 + nib4,16) >= 0x80:
     print "BT $%X" % (pc +4 + 2*(int(nib3 + nib4,16) -0x100))  #	89dd
     codeoffset = "%X" % (pi + 4 + 2*(int(nib3 + nib4,16) - 0x100))
     #coderef[codeoffset] = "%X" % (pc)	   					
    else:
     print "BT $%X" % (pc + 4 + 2*int(nib3 + nib4,16)) 
     codeoffset = "%X" % (pi + 4 + 2*int(nib3 + nib4,16))
     coderef[codeoffset] = "%X" % (pc)    					
    return
   if nib1 == '8' and nib2 == 'D':
    if int(nib3 + nib4,16) >= 0x80:
     print "BT/S $%X" % (pc +4 + 2*(int(nib3 + nib4,16) -0x100))
     codeoffset = "%X" % (pi + 4 + 2*(int(nib3 + nib4,16) - 0x100))
     #coderef[codeoffset] = "%X" % (pc)	   					
    else:
     print "BT/S $%X" % (pc + 4 + 2*int(nib3 + nib4,16))       #	8Ddd
     codeoffset = "%X" % (pi + 4 + 2*int(nib3 + nib4,16))
     coderef[codeoffset] = "%X" % (pc)   	   				
    return
   if nib1 == 'A':
    if int(nib2+ nib3 + nib4,16) >= 0x800:
     print "BRA $%X" % (pc+4+2*(int(nib2+ nib3 + nib4,16) - 0x1000))
     codeoffset = "%X" % (pi +4+2*(int(nib2+ nib3 + nib4,16) - 0x1000))
     #coderef[codeoffset] = "%X" % (pc)
    else:
     print "BRA $%X" % (pc+4+2*int(nib2+ nib3 + nib4,16))      #	Addd	
     codeoffset = "%X" % (pi+4+2*int(nib2+ nib3 + nib4,16))
     coderef[codeoffset] = "%X" % (pc)  					
    return
   if nib1 == '0' and nib3 == '2' and nib4 == '3':
    print "BRAF R%d = #%X" % (int(nib2,16),uregs["R%d" % int(nib2,16)])        #	0n23		
    return
   if nib1 == 'B':
    if int(nib2 + nib3 + nib4,16) >= 0x800:
     print "BSR $%X" % (pc+4+2*(int(nib2+ nib3 + nib4,16) - 0x1000))
     codeoffset = "%X" % (pi +4+2*(int(nib2+ nib3 + nib4,16) - 0x1000))
     #coderef[codeoffset] = "%X" % (pc)
    else:
     print "BSR $%X" % (pc+4+2*int(nib2+ nib3 + nib4,16))  			#	Bddd	
     codeoffset = "%X" % (pi+4+2*int(nib2+ nib3 + nib4,16))
     coderef[codeoffset] = "%X" % (pc)  	   						
    return
   if nib1 == '0' and nib3 == '0' and nib4 == '3':
    print "BSRF R%d = #%X" % (int(nib2,16),uregs["R%d" % int(nib2,16)])         #	0n03	
    codeoffset = "%X" % (uregs["R%d" % int(nib2,16)])
    coderef[codeoffset] = "%X" % (pc)
    return
   if nib1 == '4' and nib3 == '2' and nib4 == 'B':
    if nib2 == '2' and uregs["R%d" % int(nib2,16)] == 0x80020070:
     print "JMP @R%d = #%X ; syscall(%X)" % (int(nib2,16),uregs["R%d" % int(nib2,16)],uregs["R0"]) 	#	4n2B
    else:
     print "JMP @R%d = #%X" % (int(nib2,16),uregs["R%d" % int(nib2,16)]) 	#	4n2B
    codeoffset = "%X" % (uregs["R%d" % int(nib2,16)])
    coderef[codeoffset] = "%X" % (pc)	
    return
   if nib1 == '4' and nib3 == '0' and nib4 == 'B':
    print "JSR @R%d = #%X" % (int(nib2,16),uregs["R%d" % int(nib2,16)]) 	#	4n0B
    codeoffset = "%X" % (uregs["R%d" % int(nib2,16)] -pcstart + start)
    coderef[codeoffset] = "%X" % (pc)	
    return						
   if nib1 == '0' and nib2 == '0' and nib3 == '0' and nib4 == 'B':
    print "RTS"							 #	000B	   							
    return
# ---- System control instructions:				
   if  nib1 == '0' and nib2 == '0' and nib3 == '2' and nib4 == '8':
    print "CLRMAC" 						#	0028	   							
    return
   if  nib1 == '0' and nib2 == '0' and nib3 == '4' and nib4 == '8':
    print "CLRS"						 #	0048	   							
    return
   if  nib1 == '0' and nib2 == '0' and nib3 == '0' and nib4 == '8':
    print "CLRT"						 #	0008	   						
    return
   if  nib1 == '4' and nib3 == '0' and nib4 == 'E':
    print "LDC R%d,SR" % (int(nib2,16)) #		4m0E	   	 				
    return
   if nib1 == '4' and nib3 == '1' and nib4 == 'E':
    print "LDC R%d,GBR" % (int(nib2,16)) #		4m1E	   							
    return
   if nib1 == '4' and nib3 == '2' and nib4 == 'E':
    print "LDC R%d,VBR" % (int(nib2,16)) #		4m2E	   	 				
    return
   if nib1 == '4' and nib3 == '3' and nib4 == 'E':
    print "LDC R%d,SSR" % (int(nib2,16)) #		4M3E	    	 				
    return
   if nib1 == '4' and nib3 == '4' and nib4 == 'E':
    print "LDC R%d,SPC" % (int(nib2,16)) #		4m4E	   	 				
    return
   if nib1 == '4' and nib3 == '8' and nib4 == 'E':
    print "LDC R%d,R0_BANK" % (int(nib2,16)) #		4m8E	   	 				
    return
   if nib1 == '4' and nib3 == '9' and nib4 == 'E':
    print "LDC R%d,R1_BANK" % (int(nib2,16)) #		4m9E	   	 				
    return
   if nib1 == '4' and nib3 == 'A' and nib4 == 'E':
    print "LDC R%d,R2_BANK" % (int(nib2,16)) #		4mAE	   	 				
    return
   if nib1 == '4' and nib3 == 'B' and nib4 == 'E':
    print "LDC R%d,R3_BANK" % (int(nib2,16)) #		4mBE	    				
    return
   if nib1 == '4' and nib3 == 'C' and nib4 == 'E':
    print "LDC R%d,R4_BANK" % (int(nib2,16)) #		4mCE	    				
    return
   if nib1 == '4' and nib3 == 'D' and nib4 == 'E':
    print "LDC R%d,R5_BANK" % (int(nib2,16)) #		4mDE	    				
    return
   if nib1 == '4' and nib3 == 'E' and nib4 == 'E':
    print "LDC R%d,R6_BANK" % (int(nib2,16)) #		4mEE	    				
    return
   if nib1 == '4' and nib3 == 'F' and nib4 == 'E':
    print "LDC R%d,R7_BANK" % (int(nib2,16)) #		4mFE	    				
    return
   if nib1 == '4' and nib3 == '0' and nib4 == '7':
    print "LDC.L @R%d+,SR" % (int(nib2,16)) #		4m07	    				
    return
   if nib1 == '4' and nib3 == '1' and nib4 == '7':
    print "LDC.L @R%d+,GBR" % (int(nib2,16)) #		4m17	   						
    return
   if nib1 == '4' and nib3 == '2' and nib4 == '7':
    print "LDC.L @R%d+,VBR" % (int(nib2,16)) #		4m27	    				
    return
   if nib1 == '4' and nib3 == '3' and nib4 == '7':
    print "LDC.L @R%d+,SSR" % (int(nib2,16)) #		4m37	    				
    return
   if nib1 == '4' and nib3 == '4' and nib4 == '7':
    print "LDC.L @R%d+,SPC" % (int(nib2,16)) #		4m47	    				
    return
   if nib1 == '4' and nib3 == '8' and nib4 == '7':
    print "LDC.L @R%d+,R0_BANK" % (int(nib2,16)) #	4m87	   	 				
    return
   if nib1 == '4' and nib3 == '9' and nib4 == '7':
    print "LDC.L @R%d+,R1_BANK" % (int(nib2,16)) #	4m97	     	 				
    return
   if nib1 == '4' and nib3 == 'A' and nib4 == '7':
    print "LDC.L @R%d+,R2_BANK" % (int(nib2,16)) #	4mA7	     	 				
    return
   if nib1 == '4' and nib3 == 'B' and nib4 == '7':
    print "LDC.L @R%d+,R3_BANK" % (int(nib2,16)) #	4mB7	     	 				
    return
   if nib1 == '4' and nib3 == 'C' and nib4 == '7':
    print "LDC.L @R%d+,R4_BANK" % (int(nib2,16)) #	4mC7	   	 				
    return
   if nib1 == '4' and nib3 == 'D' and nib4 == '7':
    print "LDC.L @R%d+,R5_BANK" % (int(nib2,16)) #	4mD7	   	 				
    return
   if nib1 == '4' and nib3 == 'E' and nib4 == '7':
    print "LDC.L @R%d+,R6_BANK" % (int(nib2,16)) #	4mE7	   	 				
    return
   if nib1 == '4' and nib3 == 'F' and nib4 == '7':
    print "LDC.L @R%d+,R7_BANK" % (int(nib2,16)) #	4mF7	   	 				
    return
   if nib1 == '4' and nib3 == '0' and nib4 == 'A':
    print "LDS R%d,MACH" % (int(nib2,16)) 	 #	4m0A	   							
    return
   if nib1 == '4' and nib3 == '0' and nib4 == 'A':
    print "LDS R%d,MACL" % (int(nib2,16)) 	 #	4m1A	   							
    return
   if nib1 == '4' and nib3 == '2' and nib4 == 'A':
    print "LDS R%d,PR" % (int(nib2,16)) 	 #	4m2A	   							
    return
   if nib1 == '4' and nib3 == '0' and nib4 == '6':
    print "LDS.L @R%d+,MACH" % (int(nib2,16)) #		4m06	  							
    return
   if nib1 == '4' and nib3 == '1' and nib4 == '6':
    print "LDS.L @R%d+,MACL" % (int(nib2,16)) #		4m16	  							
    return
   if nib1 == '4' and nib3 == '2' and nib4 == '6':
    print "LDS.L @R%d+,PR" % (int(nib2,16)) #		4m26	  							
    return
   if nib1 == '0' and nib2 == '0' and nib3 == '3' and nib4 == '8':
    print "LDTLB" 	#				0038	   	 				
    return
   if nib1 == '0' and nib2 == '0' and nib3 == '0' and nib4 == '9':
    print "NOP" 	#				0009	   							
    return
   if nib1 == '0' and nib3 == '8' and nib4 == '3':
    print "PREF @R%d" % (int(nib2,16)) #		0n83	   							
    return
   if nib1 == '0' and nib2 == '0' and nib3 == '2' and nib4 == 'B':
    print "RTE" 	#				002B	   	 				
    return
   if nib1 == '0' and nib2 == '0' and nib3 == '5' and nib4 == 'B':
    print "SETS" 	#				0058	   							
    return
   if nib1 == '0' and nib2 == '0' and nib3 == '1' and nib4 == '8':
    print "SETT" 	#				0018	   							
    return
   if nib1 == '0' and nib2 == '0' and nib3 == '1' and nib4 == 'B':
    print "SLEEP" 	#				001B	   	 				
    return
   if nib1 == '0' and nib3 == '0' and nib4 == '2':
    print "STC SR,R%d" % (int(nib2,16)) #		0n02	  	 				
    return
   if nib1 == '0' and nib3 == '1' and nib4 == '2':
    print "STC GBR,R%d" % (int(nib2,16)) #		0n12	  							
    return
   if nib1 == '0' and nib3 == '2' and nib4 == '2':
    print "STC VBR,R%d" % (int(nib2,16)) #		0n22	  	 				
    return
   if nib1 == '0' and nib3 == '3' and nib4 == '2':
    print "STC SSR,R%d" % (int(nib2,16)) #		0n32	  	 				
    return
   if nib1 == '0' and nib3 == '4' and nib4 == '2':
    print "STC SPC,R%d" % (int(nib2,16)) #		0n42	  	
    return
   if nib1 == '0' and nib3 == '8' and nib4 == '2':
    print "STC R0_BANK,R%d" % (int(nib2,16)) #		0n82	  	 	
    return
   if nib1 == '0' and nib3 == '9' and nib4 == '2':
    print "STC R1_BANK,R%d" % (int(nib2,16)) #		0n92	  	 	
    return
   if nib1 == '0' and nib3 == 'A' and nib4 == '2':
    print "STC R2_BANK,R%d" % (int(nib2,16)) #		0nA2	  	 	
    return
   if nib1 == '0' and nib3 == 'B' and nib4 == '2':
    print "STC R3_BANK,R%d" % (int(nib2,16)) #		0nB2	  	 	
    return
   if nib1 == '0' and nib3 == 'C' and nib4 == '2':
    print "STC R4_BANK,R%d" % (int(nib2,16)) #		0nC2	  	 	
    return
   if nib1 == '0' and nib3 == 'D' and nib4 == '2':
    print "STC R5_BANK,R%d" % (int(nib2,16)) #		0nD2	  	 	
    return
   if nib1 == '0' and nib3 == 'E' and nib4 == '2':
    print "STC R6_BANK,R%d" % (int(nib2,16)) #		0nE2	  	 	
    return
   if nib1 == '0' and nib3 == 'F' and nib4 == '2':
    print "STC R7_BANK,R%d" % (int(nib2,16)) #		0nF2	  	 	
    return
   if nib1 == '4' and nib3 == '0' and nib4 == '3':
    print "STC.L SR,@R%d" % (int(nib2,16)) #		4n03	  	 	
    return
   if nib1 == '4' and nib3 == '1' and nib4 == '3':
    print "STC.L GBR,@R%d" % (int(nib2,16)) #		4n13	  		
    return
   if nib1 == '4' and nib3 == '2' and nib4 == '1':
    print "STC.L VBR,@R%d" % (int(nib2,16)) #		4n23	  	 	
    return
   if nib1 == '4' and nib3 == '3' and nib4 == '3':
    print "STC.L SSR,@R%d" % (int(nib2,16)) #		4n33	  	 	
    return
   if nib1 == '4' and nib3 == '2' and nib4 == '3':
    print "STC.L SPC,@R%d" % (int(nib2,16)) #		4n43	  	 	
    return
   if nib1 == '4' and nib3 == '8' and nib4 == '3':
    print "STC.L R0_BANK,@R%d" % (int(nib2,16)) #	4n83	   
    return
   if nib1 == '4' and nib3 == '9' and nib4 == '3':
    print "STC.L R1_BANK,@R%d" % (int(nib2,16)) #	4n93	   
    return
   if nib1 == '4' and nib3 == 'A' and nib4 == '3':
    print "STC.L R2_BANK,@R%d" % (int(nib2,16)) #	4nA3	   
    return
   if nib1 == '4' and nib3 == 'B' and nib4 == '3':
    print "STC.L R3_BANK,@R%d" % (int(nib2,16)) #	4nB3	   	 				
    return
   if nib1 == '4' and nib3 == 'C' and nib4 == '3':
    print "STC.L R4_BANK,@R%d" % (int(nib2,16)) #	4nC3	   	 				
    return
   if nib1 == '4' and nib3 == 'D' and nib4 == '3':
    print "STC.L R5_BANK,@R%d" % (int(nib2,16)) #	4nD3	   	 				
    return
   if nib1 == '4' and nib3 == 'E' and nib4 == '3':
    print "STC.L R6_BANK,@R%d" % (int(nib2,16)) #	4nE3	   	 				
    return
   if nib1 == '4' and nib3 == 'F' and nib4 == '3':
    print "STC.L R7_BANK,@R%d" % (int(nib2,16)) #	4nF3	   	 				
    return
   if nib1 == '0' and nib3 == '0' and nib4 == 'A':
    print "STS MACH,R%d" % (int(nib2,16)) #		0n0A	   							
    return
   if nib1 == '0' and nib3 == '1' and nib4 == 'A':
    print "STS MACL,R%d" % (int(nib2,16)) #		0n1A	   							
    return
   if nib1 == '0' and nib3 == '2' and nib4 == 'A':
    print "STS PR,R%d" % (int(nib2,16)) 	#	0n2A	   							
    return
   if nib1 == '4' and nib3 == '0' and nib4 == '2':
    print "STS.L MACH,@R%d" % (int(nib2,16)) 	#	4n02	   							
    return
   if nib1 == '4' and nib3 == '1' and nib4 == '2':
    print "STS.L MACL,@R%d" % (int(nib2,16)) 	#	4n12	   							
    return
   if nib1 == '4' and nib3 == '2' and nib4 == '2':
    print "STS.L PR,@-R%d" % (int(nib2,16)) 	#	4n22	   							
    return
   if nib1 == 'C' and nib2 == '3':
    print "TRAPA $%s" % (nib3 + nib4)		 #	C3ii	   
    return
   print nib1+nib2+nib3+nib4+" ?"

def checkaddress(addr):
 if addr >= 0x300000 and  addr < disend:
  return True
 else:
  return False

def usage():
    for line in [
        "sh3_disass.py: sh3 disassembler",
        "sh3_disass.py [opts] [file ...]",
        "opts:",
        " -s offset1   start disassembling from this file offset(must be in hex)",
        " -e offset2   end disassembling at this offset(must be in hex)",
        " -p pc        set program counter at starting offset (must be in hex)",
        ]: print line
    sys.exit()						

if __name__ == '__main__':
 global dataref
 global coderef
 global pc
 global pi
 global pcstart
 global start
 global sh3asm
 dataref = {}
 coderef = {}
 try:
     opts, args = getopt.getopt(sys.argv[1:], "p:e:s:")
 except getopt.GetoptError:
     usage()

# --- set default values ---
 pc = 0x300000        # program counter
 pcstart = 0x300000   # program counter
 start = 0x7000
 pi = 0x7000     # file position indicator
 eoffile = 0
 options = {}
 for o, a in opts:
     if o == '-s':
         start = int(a,16) 
         pi =  start     
     elif o == '-e':
         eoffile = int(a,16)
         print eoffile
     elif o == '-p':
         pc = int(a,16)
         pcstart = int(a,16)
     else:
         usage()

 for name in args:
      try:
          binfile = open(name,"rb")
          sh3asm = binfile.read()
          binfile.close()
      except IOError:
          print >>sys.stderr, "Couldn't open %s" % name
          continue
 
 if eoffile <= 0: eoffile = len(sh3asm) + eoffile
 disssize = eoffile - pi
 disend = pc + disssize
 print "Dissassembly size:",hex(disssize)
 while pc < disend:
  instr = sh3asm[pi:pi+2]
  hexinstr = binascii.hexlify(instr)  # 2 bytes => 4 nibbles
  print "%08X:" % (pc),
  disassemble(hexinstr.upper())
  pc += 2
  pi += 2
 

# Change history:
# 20110115  relaese 001:
#   print very basic sh3 assembly mnemonics
# 20110117  release 002:
#   Fixed data transfer and branch instructions and added data and code referencing
# 20110122  release 003:
#   added relevent branch instruction referencing,limited register bookeeping  and comments to syscalls
# ---------------------
# TODO list is too long to list, only doing whats needed
# ---------------------